module Sap4ruby
  class Client
    include Sap4ruby::Modules
    include DestinationDataProvider
    
    attr_accessor :connection_keys, 
                  :abap_properties, 
                  :sap_server
    
    def initialize
      @sap_server = "SAP_SERVER"
      @abap_properties = Properties.new
      @connection_keys = {
        :ashost => Sap4ruby.HOST,
        :sysnr => Sap4ruby.SYSNR,
        :lang => Sap4ruby.LANGUAGE,
        :client => Sap4ruby.CLIENT,
        :user => Sap4ruby.USER,
        :passwd => Sap4ruby.PASSWORD
      }
      
      @connection_keys.each do |key, value| 
        @abap_properties.put "jco.client.#{key}", value
      end
    end

    def get_destination_properties(system); @abap_properties end
    def set_destination_data_event_listener(eventListener); end
    def supports_events; false end
    
    class << self
      def destination
        provider = Client.new
        Environment.register_destination_data_provider(provider) unless Environment.is_destination_data_provider_registered?
        JCoDestinationManager.get_destination("SAP_SERVER")
      end
    end
  end
end
