module Sap4ruby
  class FunctionModule
    attr_accessor :importing, :exporting, :tables

    # Param on constructor
    def initialize(function_module_name)
      @destination = Sap4ruby::Client.destination
      @function = @destination.get_repository.get_function(function_module_name)
      importing_accessors,table_accessors = {}, {}

      @function.get_import_parameter_list.each do |importing_parameter|
        importing_sym = importing_parameter.get_name.downcase.to_sym
        structure_fields = {}

        if importing_parameter.is_structure?
          importing_parameter.get_structure.each do |str|
            structure_fields[str.get_name.downcase.to_sym] = str.get_value.to_s
          end
        end

        param_default_value = (structure_fields.empty?) ? importing_parameter.get_value.to_s : structure_fields
        importing_accessors[importing_sym] = param_default_value
      end      

      @importing = OpenStruct.new(importing_accessors)
      @function.get_table_parameter_list.each do |table_parameter|
        table_sym = table_parameter.get_name.downcase.to_sym
        table_accessors[table_sym] = []
      end

      @tables = OpenStruct.new(table_accessors)
    end

    def execute
      @importing.each do |param, value|
        if value.is_hash?

        else
          @function.get_import_parameter_list.set_value(param.to_s.upcase, value)
        end
      end

      @function.execute(destination)

      @function.get_export_parameter_list.each do |exporting_parameter|
        if exporting_parameter.is_structure?

        else
          @exporting[params.get_name.to_sym] = params.get_string
        end
        
      end

      @function.get_table_parameter_list.each do |table|
      end
    end

    private
      attr_accessor :destination, :function
  end
end
